/**
 * What the kobold was up to in the well.
 */
function HamletWellShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.drankWater = false;
    this.drowned = false;
    this.fell = false;

    this.scrapedThigh = false;
    this.escapedClimb = false;
    this.escapedRope = false;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {HamletWellShared-stripped} well A HamletWellShared object, stripped of private members and all functions.
     */
    this.load = function (well) {
        if (!well) {
            that.load(new HamletWellShared());
            return;
        }
        that.drankWater = well.drankWater || false;
        that.drowned = well.drowned || false;
        that.fell = well.fell || false;

        that.scrapedThigh = well.scrapedThigh || false;
        that.escapedClimb = well.escapedClimb || false;
        that.escapedRope = well.escapedRope || false;
    };
}
