/**
 * Controller for the unknown part of the forest scene.
 * @param {string} sceneId The id of the scene.
 */
function ForestUnknownController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var id = sceneId;

    var continueId = "unknownContinue";
    var baseId = "unknownBase";
    var cockId = "unknownCock";
    var pantsId = "unknownPants";
    var underwearId = "unknownUnderwear";
    var weaponId = "unknownWeapon";
    var rearExposedId = "unknownRearExposed";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.pry = new ForestUnknownPryController(id);
    this.yank = new ForestUnknownYankController(id);
    this.base = new BaseController(baseId);

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    this.continue = function () {
        global.kobold.history.setKey(id, continueId, true);
    };

    this.hasContinued = function () {
        return global.kobold.history.has(id, continueId);
    };


    function BaseController(key) {
        this.get = function () {
            return global.kobold.history.getKey(id, key);
        };
        this.set = function (choice) {
            global.kobold.history.setKey(id, key, choice);
        };
        this.has = function () {
            return global.kobold.history.has(id, key);
        };
    }


    this.cock = function () {
        global.kobold.history.setIfNotSet(id, cockId, global.kobold.body.dick);
        return global.kobold.history.getKey(id, cockId);
    };

    this.pants = function () {
        global.kobold.history.setIfNotSet(id, pantsId, global.kobold.inventory.equipment.pants);
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, pantsId));
    };

    this.underwear = function () {
        global.kobold.history.setIfNotSet(id, underwearId, global.kobold.inventory.equipment.underwear);
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, underwearId));
    };
    this.weapon = function () {
        global.kobold.history.setIfNotSet(id, weaponId, global.kobold.inventory.equipment.weapon);
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, weaponId));
    };
    this.rearExposed = function () {
        global.kobold.history.setIfNotSet(id, rearExposedId, global.kobold.inventory.equipment.rearExposed());
        return global.kobold.history.getKey(id, rearExposedId);
    };
    this.introSound = new AudioController(id, "res/audio/dark_ambience.mp3", 300);
}
