/**
 * Controller for the Farmer's House scene.
 * @param {string} sceneId The id of the scene.
 */
function FarmerHouseController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var id = sceneId;
    SceneController.call(this, id);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    function postShedChange() {
        if (that.shed.get() === FarmerHouseShedChoice.NOWEAPON) {
            global.kobold.status.physical.decrease(10, "Cut by rusty metal");
            global.kobold.status.mental.decrease(10, "Beaten by garbage");
        } else {
            global.kobold.inventory.equipment.wear(new KoboldTrident());
            global.kobold.status.mental.increase(5, "Crafted weapon");
            global.kobold.status.stamina.decrease(10, "Hard work");
        }
    }

    function postShedChangeNote() {
        if (that.shed.get() === FarmerHouseShedChoice.NOWEAPON) {
            return global.ui.change.buildNotification([
                new Change("Rust-cut", "Health", -10),
                new Change("Beaten by garbage", "Sanity", -10)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Crafted", global.kobold.inventory.createItemWithTooltip(new KoboldTrident(), true), +1),
                new Change("Made something", "Sanity", +5),
                new Change("Hard work", "Stamina", -10)
            ]);
        }
    }

    function followChange() {
        global.kobold.inventory.bag.addConsumable(new Sandwich(), 2);
    }

    function followChangeNote() {
        return global.ui.change.buildNotification([
            new Change("Loot", global.kobold.inventory.createItemWithTooltip(new Sandwich(), true), +2)
        ]);
    }

    function cabinetChange() {
        if (that.cabinet.get() === FarmerHouseCabinetChoice.DRAWER) {
            global.kobold.status.mental.decrease(5, "Frustration");
            global.kobold.inventory.bag.addMisc(new CopperRing());
        } else if (that.cabinet.get() === FarmerHouseCabinetChoice.PRY) {
            global.kobold.inventory.coins += 20;
        } else {
            global.kobold.inventory.bag.addConsumable(new CouragePotion());
        }
    }

    function cabinetChangeNote() {
        if (that.cabinet.get() === FarmerHouseCabinetChoice.DRAWER) {
            return global.ui.change.buildNotification([
                new Change("Frustration", "Sanity", -5),
                new Change("Loot", global.kobold.inventory.createItemWithTooltip(new CopperRing(), true), +1)
            ]);
        } else if (that.cabinet.get() === FarmerHouseCabinetChoice.PRY) {
            return global.ui.change.buildNotification([
                new Change("Loot", "Gold", +20)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Loot", global.kobold.inventory.createItemWithTooltip(new CouragePotion(), true), +1)
            ]);
        }
    }

    function wrestleChange() {
        global.kobold.status.physical.decrease(5, "Slapped");
        global.kobold.status.stamina.decrease(15, "Wrestling");
    }

    function wrestleChangeNote() {
        return global.ui.change.buildNotification([
            new Change("Slapped", "Health", -5),
            new Change("Wrestling", "Stamina", -15)
        ]);
    }

    function wrestleLootChange() {
        global.kobold.inventory.addItem(new FancyGlasses());
        global.kobold.status.stamina.decrease(10, "Choking a housewife");
    }

    function wrestleLootChangeNote() {
        return global.ui.change.buildNotification([
            new Change("Loot", global.kobold.inventory.createItemWithTooltip(new FancyGlasses(), true), +1),
            new Change("Further wrestling", "Stamina", -10)
        ]);
    }

    function rapeChange() {
        if (that.wrestle.has()) {
            // Wrestle rape change
            if (that.misc.dick()) {
                global.kobold.body.dickVirgin = false;
                global.kobold.status.mental.increase(10, "Sadistic pleasure");
                global.kobold.status.stamina.decrease(15, "Forceful buttsex");
                global.kobold.status.exertion.increase(25, "Forceful buttsex");
            } else {
                global.kobold.status.mental.decrease(5, "Sadism denied");
                global.kobold.status.exertion.increase(5, "Fingered human ass");
            }
        } else if (that.tied.has()) {
            // Tied rape change
            global.kobold.status.mental.increase(10, "Sadistic pleasure");
            global.kobold.status.stamina.decrease(10, "Non-penetrative sex");
            global.kobold.status.exertion.increase(20, "Non-penetrative sex");
        } else {
            // Forced oral change
            if (that.misc.dick()) {
                global.kobold.body.dickVirgin = false;
            }
            global.kobold.status.mental.increase(10, "Sadistic pleasure");
            global.kobold.status.stamina.decrease(10, "Facefucking housewife");
            global.kobold.status.exertion.increase(20, "Facefucking housewife");
        }
    }

    function rapeChangeNote() {
        if (that.wrestle.has()) {
            // Wrestle rape note
            if (that.misc.dick()) {
                return global.ui.change.buildNotification([
                    new Change("Dominated human", "Sanity", +10),
                    new Change("Buttsex", "Stamina", -15),
                    new Change("Buttsex", "Sexual exhaustion", +25, true)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Dominated human", "Sanity", +10),
                    new Change("Pleasure denied", "Sanity", -15),
                    new Change("Pleasure denied", "Sexual exhaustion", +5, true)
                ]);
            }
        } else if (that.tied.has()) {
            // Tied rape change note
            return global.ui.change.buildNotification([
                new Change("Dominated human", "Sanity", +10),
                new Change("Non-penetrative sex", "Stamina", -10),
                new Change("Non-penetrative sex", "Sexual exhaustion", +20, true)
            ]);
        } else {
            // Forced oral change note
            return global.ui.change.buildNotification([
                new Change("Dominated human", "Sanity", +10),
                new Change("Facefucking", "Stamina", -10),
                new Change("Facefucking", "Sexual exhaustion", +20, true)
            ]);
        }
    }

    function partialLootChange() {
        global.kobold.inventory.bag.addConsumable(new Bread());
        global.kobold.inventory.bag.addConsumable(new Butter());
        global.kobold.inventory.bag.addConsumable(new Ham());
    }

    function partialLootChangeNote() {
        return global.ui.change.buildNotification([
            new Change("Loot", global.kobold.inventory.createItemWithTooltip(new Bread(), true), +1),
            new Change("Loot", global.kobold.inventory.createItemWithTooltip(new Butter(), true), +1),
            new Change("Loot", global.kobold.inventory.createItemWithTooltip(new Ham(), true), +1)
        ]);
    }

    function fullLootChange() {
        global.kobold.inventory.addItem(new FancyGlasses());
    }

    function fullLootChangeNote() {
        return global.ui.change.buildNotification([
            new Change("Loot", global.kobold.inventory.createItemWithTooltip(new FancyGlasses(), true), +1)
        ]);
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.varanarSceneName = "NightTwo";
    this.varanarFolderName = "Varanar";
    
    this.misc = new MiscController(id);
    this.arrival = new ChoiceController(id, "arrival");

    this.steal = new ChoiceController(id, "steal");
    this.shed = new ChoiceController(id, "shed");
    this.postshed = new ChangeController(id, "postshed", postShedChange, postShedChangeNote);
    this.inside = new ChoiceController(id, "inside");
    this.follow = new ChangeController(id, "follow", followChange, followChangeNote);
    this.cabinet = new ChoiceController(id, "cabinet");
    this.cabinetSteal = new ChangeController(id, "cabinetSteal", cabinetChange, cabinetChangeNote);

    this.confront = new ChoiceController(id, "confront");
    this.wrestle = new ChangeController(id, "wrestle", wrestleChange, wrestleChangeNote);
    this.choke = new ChangeController(id, "choke", wrestleLootChange, wrestleLootChangeNote);
    this.rape = new ChangeController(id, "rape", rapeChange, rapeChangeNote);
    this.scared = new ChoiceController(id, "scared");
    this.tied = new ChoiceController(id, "tied");
    this.partialLoot = new ChangeController(id, "partialLoot", partialLootChange, partialLootChangeNote);
    this.fullLoot = new ChangeController(id, "fullLoot", fullLootChange, fullLootChangeNote);


    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    this.hasRope = function () {
        global.kobold.history.setIfNotSet(id, "hasRope", global.kobold.inventory.bag.hasMisc(ItemEnum.ROPE));
        return global.kobold.history.getKey(id, "hasRope");
    };

    this.removeRope = function () {
        global.kobold.history.doIfNotSet(id, "removeRope", true, function () {
            global.kobold.inventory.bag.removeMisc(ItemEnum.ROPE);
        });
        return "";
    };

    this.intimidateFail = function () {
        global.kobold.history.doIfNotSet(id, "wrestleFail", true, function () {
            global.kobold.status.stamina.decrease(15, "Ran from farmer");
        });
        return global.ui.change.buildNotification([
            new Change("Ran", "Stamina", -15)
        ]);
    };

    this.threatenFail = function () {
        global.kobold.history.doIfNotSet(id, "wrestleFail", true, function () {
            global.kobold.status.stamina.decrease(15, "Ran from farmer");
        });
        return global.ui.change.buildNotification([
            new Change("Ran", "Stamina", -15)
        ]);
    };

    this.wrestleFail = function () {
        global.kobold.history.doIfNotSet(id, "wrestleFail", true, function () {
            global.kobold.status.physical.decrease(15, "Elbow-bashed");
            global.kobold.status.mental.decrease(10, "Beaten by a woman");
            global.kobold.status.stamina.decrease(15, "Ran from angry mob");
        });
        return global.ui.change.buildNotification([
            new Change("Elbow-bashed", "Health", -15),
            new Change("Beaten by a woman", "Stamina", -15),
            new Change("Ran from angry mob", "Stamina", -15)
        ]);
    };

    this.runChange = function () {
        global.kobold.history.doIfNotSet(id, "shedRun", true, function () {
            global.kobold.status.stamina.decrease(15, "Ran from farmer");
        });
        return global.ui.change.buildNotification([
            new Change("Ran", "Stamina", -15)
        ]);
    };
}

